/*
 * This could be in another package, controllers, but golang tend to be simgle folder per concern
 */

package sampleapp

import (
	"encoding/json"
	"log"
	"net/http"
	"sampleapp/customersvc"

	"gopkg.in/mgo.v2-unstable/bson"

	"github.com/gorilla/mux"
)

type CustomerController struct {
	svc customersvc.Servicer
}

func (cc *CustomerController) GetCustomerHandler(w http.ResponseWriter, r *http.Request) {
	vars := mux.Vars(r)
	id := vars["id"]

	if !bson.IsObjectIdHex(id) {
		w.WriteHeader(http.StatusBadRequest)
		return
	}
	cust, err := cc.svc.FetchByID(id) // This should be in userservice
	if err == customersvc.ErrNotFound {
		httpErr(w, http.StatusNotFound, "Not found")
		return
	}
	if err != nil {
		httpErr(w, http.StatusInternalServerError, "Error fetching customer", err)
		return
	}
	json.NewEncoder(w).Encode(cust)
}

func (cc *CustomerController) PostCustomerHandler(w http.ResponseWriter, r *http.Request) {
	log.Println("Post")
	defer r.Body.Close()

	cust := &customersvc.Customer{}
	json.NewDecoder(r.Body).Decode(&cust)

	log.Println("Received:", cust)
	//Store user from body
}
