package customersvc_test

import (
	"os"
	"sampleapp/customersvc"
	. "sampleapp/testutils"
	"testing"

	mgo "gopkg.in/mgo.v2-unstable"
)

func MustPrepareDB() *mgo.Database {
	dbURL := os.Getenv("MONGODB")
	if dbURL == "" {
		return nil
	}
	sess, err := mgo.Dial(dbURL)
	if err != nil {
		panic(err) // MustPrepareDB
	}

	db := sess.DB("sample_test")

	return db
}

func TestStore(t *testing.T) {
	db := MustPrepareDB()
	if db == nil {
		t.Skip("Database not ready")
	}

	cs := &customersvc.Service{db}

	c := customersvc.Customer{
		Name: "Luis",
		Phone: customersvc.Phone{
			Type:   customersvc.TypMobile,
			Number: "+5545991121214",
		},
	}
	err := cs.Store(&c)
	FailNotEq(t, err, nil)
}
