package sampleapp

import (
	"log"
	"net/http"
	"sampleapp/customersvc"

	"github.com/gorilla/mux"
)

// SampleApp
type SampleApp struct {
	// Datastore for this app
	//sess *mgo.Session
	//db   *mgo.Database

	// Services
	CustomerSVC customersvc.Servicer

	// golang http router
	router *mux.Router
}

func New() *SampleApp {
	return &SampleApp{}
}

// Router returns a lazy initialized router
func (s *SampleApp) Router() *mux.Router {
	if s.router == nil {
		s.router = mux.NewRouter()
		s.InitRoutes()
	}
	return s.router
}

// ListenAndServe serves
func (s *SampleApp) ListenAndServe(addr string) {
	log.Println("Starting http at", addr)
	http.ListenAndServe(addr, s.Router())
}
