package testutils_test

import (
	"fmt"
	"runtime"
	"strings"
	"testing"
)

func FailNotEq(t *testing.T, v1 interface{}, v2 interface{}) {
	if v1 != v2 {
		t.Fatalf("%s - Not Equal %+v != %+v", line(), v1, v2)
	}
}
func FailEq(t *testing.T, v1 interface{}, v2 interface{}) {
	if v1 == v2 {
		t.Fatalf("%s - Equal %+v == %+v", line(), v1, v2)
	}
}

// Helper to show where it failed
func line() string {
	_, file, line, _ := runtime.Caller(2)
	si := strings.LastIndex(file, "/") + 1
	return fmt.Sprintf("%s:%d", file[si:], line)
}
